package com.tashow.cloud.file.controller.admin.config;

import com.tashow.cloud.common.pojo.CommonResult;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.file.controller.admin.config.vo.ConfigPageReqVO;
import com.tashow.cloud.file.controller.admin.config.vo.ConfigRespVO;
import com.tashow.cloud.file.controller.admin.config.vo.ConfigSaveReqVO;
import com.tashow.cloud.file.convert.config.ConfigConvert;
import com.tashow.cloud.file.dal.dataobject.config.ConfigDO;
import com.tashow.cloud.file.service.config.ConfigService;
import com.tashow.cloud.fileapi.enums.ErrorCodeConstants;
import jakarta.annotation.Resource;
import jakarta.validation.Valid;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;
import static com.tashow.cloud.common.pojo.CommonResult.success;


/**
 * 管理后台 - 参数配置
 */
@RestController
@RequestMapping("/file/config")
@Validated
public class ConfigController {

    @Resource
    private ConfigService configService;

    /**
     * 创建参数配置
     * @param createReqVO
     * @return
     */
    @PostMapping("/create")
    public CommonResult<Long> createConfig(@Valid @RequestBody ConfigSaveReqVO createReqVO) {
        return success(configService.createConfig(createReqVO));
    }

    /**
     * 修改参数配置
     * @param updateReqVO
     * @return
     */
    @PutMapping("/update")
    public CommonResult<Boolean> updateConfig(@Valid @RequestBody ConfigSaveReqVO updateReqVO) {
        configService.updateConfig(updateReqVO);
        return success(true);
    }

    /**
     * 删除参数配置
     * @param id
     * @return
     */
    @DeleteMapping("/delete")
    public CommonResult<Boolean> deleteConfig(@RequestParam("id") Long id) {
        configService.deleteConfig(id);
        return success(true);
    }

    /**
     * 获得参数配置
     * @param id
     * @return
     */
    @GetMapping(value = "/get")
    public CommonResult<ConfigRespVO> getConfig(@RequestParam("id") Long id) {
        return success(ConfigConvert.INSTANCE.convert(configService.getConfig(id)));
    }

    /**
     * 根据参数键名查询参数值
     * @param key
     * @return
     */
    @GetMapping(value = "/get-value-by-key")
    public CommonResult<String> getConfigKey(@RequestParam("key") String key) {
        ConfigDO config = configService.getConfigByKey(key);
        if (config == null) {
            return success(null);
        }
        if (!config.getVisible()) {
            throw exception(ErrorCodeConstants.CONFIG_GET_VALUE_ERROR_IF_VISIBLE);
        }
        return success(config.getValue());
    }

    /**
     * 获取参数配置分页
     * @param pageReqVO
     * @return
     */
    @GetMapping("/page")
    public CommonResult<PageResult<ConfigRespVO>> getConfigPage(@Valid ConfigPageReqVO pageReqVO) {
        PageResult<ConfigDO> page = configService.getConfigPage(pageReqVO);
        return success(ConfigConvert.INSTANCE.convertPage(page));
    }
}
